Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Allocation.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Allocation.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Allocation.h	(revision 88)
@@ -257,135 +375,135 @@
 
 #ifdef POSITION
-#define ALLOC2_INTERFACE( name, direction, localisation, str, it1, it2)	\
-  INTERFACE_PRINT(name);						\
-  uint32_t iterator_1 = 0;						\
-  uint32_t iterator_2 = 0;						\
-  Interface_fifo *** interface;						\
-  {									\
-    std::string separator="_";						\
-    iterator_1 = it1;							\
-    interface = new Interface_fifo ** [iterator_1];			\
-    for (uint32_t alloc_interface_it1=0; alloc_interface_it1<iterator_1; alloc_interface_it1++)	\
-      {									\
-	iterator_2 = it2;						\
-	interface [alloc_interface_it1] = new Interface_fifo * [iterator_2]; \
-	for (uint32_t alloc_interface_it2=0; alloc_interface_it2<iterator_2; alloc_interface_it2++) \
-	  {								\
-	    interface [alloc_interface_it1][alloc_interface_it2] = _interfaces->set_interface( name+separator+toString(alloc_interface_it1)+separator+toString(alloc_interface_it2), direction, localisation, str); \
-	  }								\
-      }									\
+#define ALLOC2_INTERFACE( name, direction, localisation, str, x1, x2)   \
+  INTERFACE_PRINT(name);                                                \
+  uint32_t iterator_1 = 0;                                              \
+  uint32_t iterator_2 = 0;                                              \
+  morpheo::behavioural::Interface_fifo *** interface;                   \
+  {                                                                     \
+    std::string separator="_";                                          \
+    iterator_1 = x1;                                                    \
+    interface = new morpheo::behavioural::Interface_fifo ** [iterator_1]; \
+    for (uint32_t it1=0; it1<iterator_1; it1++)                         \
+      {                                                                 \
+        iterator_2 = x2;                                                \
+        interface [it1] = new morpheo::behavioural::Interface_fifo * [iterator_2]; \
+        for (uint32_t it2=0; it2<iterator_2; it2++)                     \
+          {                                                             \
+            interface [it1][it2] = _interfaces->set_interface( name+separator+toString(it1)+separator+toString(it2), direction, localisation, str); \
+          }                                                             \
+      }                                                                 \
   }
 #else
-#define ALLOC2_INTERFACE( name, direction, localisation, str, it1, it2)	\
-  INTERFACE_PRINT(name);						\
-  uint32_t iterator_1 = 0;						\
-  uint32_t iterator_2 = 0;						\
-  Interface_fifo *** interface;						\
-  {									\
-    std::string separator="_";						\
-    iterator_1 = it1;							\
-    interface = new Interface_fifo ** [iterator_1];			\
-    for (uint32_t alloc_interface_it1=0; alloc_interface_it1<iterator_1; alloc_interface_it1++)	\
-      {									\
-	iterator_2 = it2;						\
-	interface [alloc_interface_it1] = new Interface_fifo * [iterator_2]; \
-	for (uint32_t alloc_interface_it2=0; alloc_interface_it2<iterator_2; alloc_interface_it2++) \
-	  {								\
-	    interface [alloc_interface_it1][alloc_interface_it2] = _interfaces->set_interface( name+separator+toString(alloc_interface_it1)+separator+toString(alloc_interface_it2)); \
-	  }								\
-      }									\
+#define ALLOC2_INTERFACE( name, direction, localisation, str, x1, x2)   \
+  INTERFACE_PRINT(name);                                                \
+  uint32_t iterator_1 = 0;                                              \
+  uint32_t iterator_2 = 0;                                              \
+  morpheo::behavioural::Interface_fifo *** interface;                   \
+  {                                                                     \
+    std::string separator="_";                                          \
+    iterator_1 = x1;                                                    \
+    interface = new morpheo::behavioural::Interface_fifo ** [iterator_1]; \
+    for (uint32_t it1=0; it1<iterator_1; it1++)                         \
+      {                                                                 \
+        iterator_2 = x2;                                                \
+        interface [it1] = new morpheo::behavioural::Interface_fifo * [iterator_2]; \
+        for (uint32_t it2=0; it2<iterator_2; it2++)                     \
+          {                                                             \
+            interface [it1][it2] = _interfaces->set_interface( name+separator+toString(it1)+separator+toString(it2)); \
+          }                                                             \
+      }                                                                 \
   }
 #endif
 
-#define _ALLOC2_VAL_ACK_IN( sig, name, type, it1, it2)			\
-  {									\
-    sig = new SC_IN (Tcontrol_t) ** [it1];				\
-    for (uint32_t alloc_signal_it1=0; alloc_signal_it1<it1; alloc_signal_it1++) \
-      {									\
-	sig [alloc_signal_it1] = new SC_IN (Tcontrol_t) * [it2];	\
-	for (uint32_t alloc_signal_it2=0; alloc_signal_it2<it2; alloc_signal_it2++) \
-	  {								\
-	    sig [alloc_signal_it1][alloc_signal_it2] = interface[alloc_signal_it1][alloc_signal_it2]->set_signal_valack_in (name, type); \
-	  }								\
-      }									\
-  }
-
-#define _ALLOC2_VAL_ACK_OUT( sig, name, type, it1, it2)			\
-  {									\
-    sig = new SC_OUT (Tcontrol_t) ** [it1];				\
-    for (uint32_t alloc_signal_it1=0; alloc_signal_it1<it1; alloc_signal_it1++) \
-      {									\
-	sig [alloc_signal_it1] = new SC_OUT (Tcontrol_t) * [it2];	\
-	for (uint32_t alloc_signal_it2=0; alloc_signal_it2<it2; alloc_signal_it2++) \
-	  {								\
-	    sig [alloc_signal_it1][alloc_signal_it2] = interface[alloc_signal_it1][alloc_signal_it2]->set_signal_valack_out (name, type); \
-	  }								\
-      }									\
-  }
-
-#define _ALLOC2_VALACK_IN(    sig,type, it1, it2)			\
-  {									\
-    sig = new SC_IN (Tcontrol_t) ** [it1];				\
-    for (uint32_t alloc_signal_it1=0; alloc_signal_it1<it1; alloc_signal_it1++)	\
-      {									\
-	sig [alloc_signal_it1] = new SC_IN (Tcontrol_t) * [it2];	\
-	for (uint32_t alloc_signal_it2=0; alloc_signal_it2<it2; alloc_signal_it2++) \
-	  {								\
-	    sig [alloc_signal_it1][alloc_signal_it2] = interface[alloc_signal_it1][alloc_signal_it2]->set_signal_valack_in (type); \
-	  }								\
-      }									\
-  }
-
-#define _ALLOC2_VALACK_OUT(    sig,type, it1, it2)			\
-  {									\
-    sig = new SC_OUT (Tcontrol_t) ** [it1];				\
-    for (uint32_t alloc_signal_it1=0; alloc_signal_it1<it1; alloc_signal_it1++)	\
-      {									\
-	sig [alloc_signal_it1] = new SC_OUT (Tcontrol_t) * [it2];	\
-	for (uint32_t alloc_signal_it2=0; alloc_signal_it2<it2; alloc_signal_it2++) \
-	  {								\
-	    sig [alloc_signal_it1][alloc_signal_it2] = interface[alloc_signal_it1][alloc_signal_it2]->set_signal_valack_out (type); \
-	  }								\
-      }									\
-  }
-
-#define _ALLOC2_SIGNAL_IN( sig, name, type, size, it1, it2)		\
-  {									\
-    sig = new SC_IN (type) ** [it1];					\
-    for (uint32_t alloc_signal_it1=0; alloc_signal_it1<it1; alloc_signal_it1++) \
-      {									\
-	sig [alloc_signal_it1] = new SC_IN (type) * [it2];		\
-	for (uint32_t alloc_signal_it2=0; alloc_signal_it2<it2; alloc_signal_it2++) \
-	  {								\
-	    if (size > 0)						\
-	      {								\
-		sig [alloc_signal_it1][alloc_signal_it2] = interface[alloc_signal_it1][alloc_signal_it2]->set_signal_in <type> (name, size); \
-	      }								\
-	    else							\
-	      {								\
-		log_printf(INFO,true,FUNCTION,_("%s %s.%s.%s : size is nul."),MSG_INFORMATION,_component->get_name().c_str(),interface[alloc_signal_it1][alloc_signal_it2]->get_name().c_str(),name); \
-	      }								\
-	  }								\
-      }									\
-  }
-
-#define _ALLOC2_SIGNAL_OUT( sig, name, type, size, it1, it2)		\
-  {									\
-    sig = new SC_OUT (type) ** [it1];					\
-    for (uint32_t alloc_signal_it1=0; alloc_signal_it1<it1; alloc_signal_it1++) \
-      {									\
-	sig [alloc_signal_it1] = new SC_OUT (type) * [it2];		\
-	for (uint32_t alloc_signal_it2=0; alloc_signal_it2<it2; alloc_signal_it2++) \
-	  {								\
-	    if (size > 0)						\
-	      {								\
-		sig [alloc_signal_it1][alloc_signal_it2] = interface[alloc_signal_it1][alloc_signal_it2]->set_signal_out <type> (name, size); \
-	      }								\
-	    else							\
-	      {								\
-		log_printf(INFO,true,FUNCTION,_("%s %s.%s.%s : size is nul."),MSG_INFORMATION,_component->get_name().c_str(),interface[alloc_signal_it1][alloc_signal_it2]->get_name().c_str(),name); \
-	      }								\
-	  }								\
-      }									\
+#define _ALLOC2_VAL_ACK_IN( sig, name, type, x1, x2)                    \
+  {                                                                     \
+    sig = new SC_IN (Tcontrol_t) ** [x1];                               \
+    for (uint32_t it1=0; it1<x1; it1++)                                 \
+      {                                                                 \
+        sig [it1] = new SC_IN (Tcontrol_t) * [x2];                      \
+        for (uint32_t it2=0; it2<x2; it2++)                             \
+          {                                                             \
+            sig [it1][it2] = interface[it1][it2]->set_signal_valack_in (name, type); \
+          }                                                             \
+      }                                                                 \
+  }
+
+#define _ALLOC2_VAL_ACK_OUT( sig, name, type, x1, x2)                   \
+  {                                                                     \
+    sig = new SC_OUT (Tcontrol_t) ** [x1];                              \
+    for (uint32_t it1=0; it1<x1; it1++)                                 \
+      {                                                                 \
+        sig [it1] = new SC_OUT (Tcontrol_t) * [x2];                     \
+        for (uint32_t it2=0; it2<x2; it2++)                             \
+          {                                                             \
+            sig [it1][it2] = interface[it1][it2]->set_signal_valack_out (name, type); \
+          }                                                             \
+      }                                                                 \
+  }
+
+#define _ALLOC2_VALACK_IN(    sig,type, x1, x2)                         \
+  {                                                                     \
+    sig = new SC_IN (Tcontrol_t) ** [x1];                               \
+    for (uint32_t it1=0; it1<x1; it1++)                                 \
+      {                                                                 \
+        sig [it1] = new SC_IN (Tcontrol_t) * [x2];                      \
+        for (uint32_t it2=0; it2<x2; it2++)                             \
+          {                                                             \
+            sig [it1][it2] = interface[it1][it2]->set_signal_valack_in (type); \
+          }                                                             \
+      }                                                                 \
+  }
+
+#define _ALLOC2_VALACK_OUT(    sig,type, x1, x2)                        \
+  {                                                                     \
+    sig = new SC_OUT (Tcontrol_t) ** [x1];                              \
+    for (uint32_t it1=0; it1<x1; it1++)                                 \
+      {                                                                 \
+        sig [it1] = new SC_OUT (Tcontrol_t) * [x2];                     \
+        for (uint32_t it2=0; it2<x2; it2++)                             \
+          {                                                             \
+            sig [it1][it2] = interface[it1][it2]->set_signal_valack_out (type); \
+          }                                                             \
+      }                                                                 \
+  }
+
+#define _ALLOC2_SIGNAL_IN( sig, name, type, size, x1, x2)               \
+  {                                                                     \
+    sig = new SC_IN (type) ** [x1];                                     \
+    for (uint32_t it1=0; it1<x1; it1++)                                 \
+      {                                                                 \
+        sig [it1] = new SC_IN (type) * [x2];                            \
+        for (uint32_t it2=0; it2<x2; it2++)                             \
+          {                                                             \
+            if (size > 0)                                               \
+              {                                                         \
+                sig [it1][it2] = interface[it1][it2]->set_signal_in <type> (name, size); \
+              }                                                         \
+            else                                                        \
+              {                                                         \
+                PRINT_SIZE_NUL(_component,interface[it1][it2],name);    \
+              }                                                         \
+          }                                                             \
+      }                                                                 \
+  }
+
+#define _ALLOC2_SIGNAL_OUT( sig, name, type, size, x1, x2)              \
+  {                                                                     \
+    sig = new SC_OUT (type) ** [x1];                                    \
+    for (uint32_t it1=0; it1<x1; it1++)                                 \
+      {                                                                 \
+        sig [it1] = new SC_OUT (type) * [x2];                           \
+        for (uint32_t it2=0; it2<x2; it2++)                             \
+          {                                                             \
+            if (size > 0)                                               \
+              {                                                         \
+                sig [it1][it2] = interface[it1][it2]->set_signal_out <type> (name, size); \
+              }                                                         \
+            else                                                        \
+              {                                                         \
+                PRINT_SIZE_NUL(_component,interface[it1][it2],name);    \
+              }                                                         \
+          }                                                             \
+      }                                                                 \
   }
 
